const Promise = require('bluebird');
const Nick = require("../../lib/Nick");
const nick = new Nick({
    headless: false
});
const testUrl = "http://edition.cnn.com/2017/12/15/politics/next-alabama-states/index.html";

const runTab = async (url) => {
    const tab = await nick.newTab();
    await tab.open(url);
    await tab.untilVisible("body");
    await tab.inject(`examples/es8/jquery-3.2.1.min.js`);
    await tab.wait(3000);
    await tab.scrollToBottom();

    const results = await tab.evaluate((arg, callback)=>{
        const blocks = $("body").find('div');
        callback(null, blocks.length);
    });

    await tab.close();
};

const runTestTabs = () => {
    const fakeArray = new Array(100);

    return Promise.each(fakeArray, () => {
        return runTab(testUrl);
    });
}

(async ()=> {
    await runTestTabs();
    console.log("Test complete!");
    nick.exit();
})();
